-------------------------------------------------------------------------
--  TOP CPU PROCESSOR SIMULATION TESTBENCH
-------------------------------------------------------------------------
library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

entity CPU_tb is
end CPU_tb;

architecture cpu_tb of cpu_tb is

	signal ck, rst, selCPU: std_logic;
	signal addressSERIAL, data_out: std_logic_vector(31 downto 0) := (others => '0');

begin

	top: entity work.MR4_with_memories port map
	(
		clock => ck,
		reset => rst,
		selCPU => selCPU,
		addressSERIAL => addressSERIAL,
		data_out => data_out
	);

	-- dispara o dump de memria
	selCPU <= '0', '1' after 15 us;    -- tranca a CPU

	--- gerao do endereo para fazer um dump de memria
	process
	begin
		wait for 20 ns;
		if selCPU = '1' then
			addressSERIAL <= addressSERIAL + 4;
		end if;
	end process;

	rst <='1', '0' after 120 ns;       -- generates the reset signal

	process                          -- generates the clock signal
	begin
		ck <= '1', '0' after 10 ns;
		wait for 20 ns;
	end process;

end cpu_tb;
